import { FormulaireFixedVar } from "./form-fixedvar";
import { FieldSet } from "../elements/fieldset";

import { IObservable, Session, SectionNub } from "jalhyd";

export class FormulaireSection extends FormulaireFixedVar {

    update(sender: IObservable, data: any) {
        super.update(sender, data);
        // changement de propriété du FieldSet contenant le select de choix du type de section
        if (sender instanceof FieldSet && sender.id === "fs_section" && data.action === "propertyChange") {
            // replace underlying section without replacing whole Nub
            const newSect = Session.getInstance().createSection(data.value);
            (this._currentNub as SectionNub).setSection(newSect);
            // reflect changes in GUI
            for (const fs of this.allFieldsets) {
                // show / hide dependent fields
                fs.updateFields();
            }
            this.reset();
        }
    }

}
